#property copyright "ChartSecret.com"
#property link      "www.ChartSecret.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 SkyBlue
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_level1 -90.0
#property indicator_level2 190.0

extern string s.1 = "Settings";
extern int IPeriod = 80;
extern bool Alert.Message = TRUE;
extern bool Alert.Email = TRUE;
double g_ibuf_96[];
double g_ibuf_100[];
double g_ibuf_104[];
double g_ibuf_108[];
double g_ibuf_112[];
double g_ibuf_116[];

int init() {
   IndicatorBuffers(6);
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, g_ibuf_96);
   SetIndexEmptyValue(0, -1);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexBuffer(1, g_ibuf_100);
   SetIndexEmptyValue(1, -1);
   SetIndexStyle(2, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexBuffer(2, g_ibuf_104);
   SetIndexEmptyValue(2, -1);
   SetIndexStyle(3, DRAW_NONE, STYLE_SOLID, 2);
   SetIndexBuffer(3, g_ibuf_116);
   SetIndexBuffer(4, g_ibuf_108);
   SetIndexBuffer(5, g_ibuf_112);
   IndicatorShortName("Range Oscillator(" + IPeriod + ")");
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   double ld_32;
   double ld_40;
   double ld_48;
   int l_bars_60;
   double ld_72;
   double ld_0 = 0;
   double ld_8 = 0;
   double ld_16 = 0;
   double ld_24 = 0;
   int li_56 = IndicatorCounted();
   if (li_56 >= 0) {
      if (li_56 > 0) li_56--;
      l_bars_60 = Bars;
      for (int li_64 = l_bars_60; li_64 >= 0; li_64--) {
         if (li_64 != 0 && g_ibuf_96[li_64] != -1.0) continue;
         ld_0 = 0;
         ld_8 = 0;
         ld_16 = 0;
         ld_24 = 0;
         if (ld_0 == 0.0 && ld_8 == 0.0 && ld_16 == 0.0 && ld_24 == 0.0) {
            for (int l_count_68 = 0; l_count_68 < IPeriod; l_count_68++) {
               ld_0 += Close[l_count_68 + li_64];
               ld_8 += (Close[l_count_68 + li_64]) * l_count_68;
               ld_16 += l_count_68;
               ld_24 += l_count_68 * l_count_68;
            }
         } else {
            ld_0 -= Close[li_64 - 1];
            ld_0 += Close[IPeriod + li_64];
            ld_8 += (Close[IPeriod + li_64]) * IPeriod;
            ld_16 += IPeriod;
            ld_24 += IPeriod * IPeriod;
         }
         ld_48 = ld_24 * IPeriod - ld_16 * ld_16;
         ld_40 = (ld_8 * IPeriod - ld_16 * ld_0) / ld_48;
         ld_32 = (ld_0 - ld_16 * ld_40) / IPeriod;
         if (ld_40 > 0.0) ld_72 = 100;
         else ld_72 = -100;
         g_ibuf_108[li_64] = LinRegr(1, ld_32, ld_40, ld_48, li_64);
         g_ibuf_112[li_64] = LinRegr(0, ld_32, ld_40, ld_48, li_64);
         if (g_ibuf_112[li_64] - g_ibuf_108[li_64] != 0.0) g_ibuf_96[li_64] = 100.0 * ((Close[li_64] - g_ibuf_108[li_64]) / (g_ibuf_112[li_64] - g_ibuf_108[li_64])) + ld_72;
         if (g_ibuf_96[li_64] >= 190.0) g_ibuf_100[li_64] = g_ibuf_96[li_64];
         if (g_ibuf_96[li_64] <= -90.0) g_ibuf_104[li_64] = g_ibuf_96[li_64];
      }
      if (Low[0] == High[0] && Low[0] == Close[0] && Low[0] == Open[0]) {
         if (g_ibuf_100[1] == -1.0 && g_ibuf_100[2] != -1.0) {
            if (Alert.Message) Alert("Range Oscillator Signal: " + Symbol() + " is OverBought - prepare for Short trade.");
            if (Alert.Email) SendMail("Range Oscillator Signal", "Range Oscillator Signal: " + Symbol() + " is OverBought - prepare for Short trade.");
         }
         if (g_ibuf_104[1] == -1.0 && g_ibuf_104[2] != -1.0) {
            if (Alert.Message) Alert("Range Oscillator Signal: " + Symbol() + " is OverSold - prepare for Long trade.");
            if (Alert.Email) SendMail("Range Oscillator Signal", "Range Oscillator Signal: " + Symbol() + " is OverSold - prepare for Long trade.");
         }
      }
   }
   return (0);
}

double LinRegr(bool ai_0, double ad_4, double ad_12, double ad_unused_20, int ai_28) {
   double lda_48[500];
   double lda_52[500];
   double lda_56[500];
   double ld_32 = 0.0;
   double ld_40 = 0.0;
   for (int l_index_60 = 0; l_index_60 < IPeriod; l_index_60++) lda_48[l_index_60] = ad_4 + ad_12 * l_index_60;
   for (l_index_60 = 0; l_index_60 < IPeriod; l_index_60++) {
      if (Close[l_index_60 + ai_28] - lda_48[l_index_60] > ld_32) ld_32 = Close[l_index_60 + ai_28] - lda_48[l_index_60];
      if (lda_48[l_index_60] - (Close[l_index_60 + ai_28]) > ld_40) ld_40 = lda_48[l_index_60] - (Close[l_index_60 + ai_28]);
   }
   if (ld_32 > ld_40) {
      for (l_index_60 = 0; l_index_60 < IPeriod; l_index_60++) {
         lda_52[l_index_60] = ad_4 - ld_32 + ad_12 * l_index_60;
         lda_56[l_index_60] = ad_4 + ld_32 + ad_12 * l_index_60;
      }
   } else {
      for (l_index_60 = 0; l_index_60 < IPeriod; l_index_60++) {
         lda_52[l_index_60] = ad_4 - ld_40 + ad_12 * l_index_60;
         lda_56[l_index_60] = ad_4 + ld_40 + ad_12 * l_index_60;
      }
   }
   if (ai_0) return (lda_52[0]);
   return (lda_56[0]);
}